
#include "inc.h"

#include "lib.h"
#include "printf.h"
#include "iwram_arm.h"
#include "div_arm.h"

#include "casl.h"
#include "comet.h"

#include "main.h"


//Mode3
//SPR J[\

//F DC̒`͂P̂
//       adr̐l͂łȂ قFXiOOG

//---------------------------------------------------------------------------
//commet.c
//ST_COMET  Comet;
//casl.c
//extern ST_CASL Casl;
//casl.c
extern ST_CURSOR Cursor;

//---------------------------------------------------------------------------
u8 State;								//is󋵃tO

//---------------------------------------------------------------------------
EWRAM_CODE int main()
{
	State = STATE_INIT;

	for(;;)
	{
		switch(State)
		{
			case STATE_INIT:    StateInit();    break;
			case STATE_RESET:   StateReset();   break;
			case STATE_INPUT:   StateInput();   break;
			case STATE_EDIT:    StateEdit();    break;
			case STATE_COMPILE: StateCompile(); break;
			case STATE_RUN:     StateRun();     break;
			case STATE_MSG:     StateMsg();     break;

			default:
				DebugMessage("Err: Main State");
				break;
		}
	}

	return 0;
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateInit()
{
	InitWS();
	InitKey();
	InitSprite();
	InitFont();
	InitIRQ();

	SetMode(MODE_3 | BG2_ENABLE | OBJ_ENABLE | OBJ_MAP_2D);

	State = STATE_RESET;
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateReset()
{
	CaslInit();
	CursorInit();

	CaslLoadSRAM();
	DrawEditScreen();

	State = STATE_INPUT;
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateInput()
{
	WaitForVsync();

	ST_CURSOR* p = &Cursor;
	p->key       = KeyGet();

	if(p->key == KEY_NONE)
	{
		return;
	}
	if(p->key & KEY_DEC)
	{
		//\L[ȊOꂽꍇASTATEύX܂
		State = STATE_EDIT;
		return;
	}

	CursorInput();
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateEdit()
{
	WaitForVsync();

	ST_CURSOR* p = &Cursor;

	//Compile
	if(p->key == KEY_START)
	{
		State = STATE_COMPILE;
		return;
	}
/*
	//SRAMLoad
	if(p->key == KEY_R)
	{
		CaslLoadSRAM();

		State = STATE_INPUT;
		return;
	}

	//SRAMSave
	if(p->key == KEY_L)
	{
		CaslSaveSRAM();

		State = STATE_INPUT;
		return;
	}
*/
	CaslEdit();
	State = STATE_INPUT;
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateCompile()
{
	CometInit();
	CompileInit();
	CompileExec();
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateRun()
{
	CometExec();
}
//---------------------------------------------------------------------------
EWRAM_CODE void StateMsg()
{
	
}
//---------------------------------------------------------------------------
EWRAM_CODE void InitWS()
{
	//J[hbW̕Wݒ
	REG_WSCNT = 0x4317;
}
//---------------------------------------------------------------------------
EWRAM_CODE void InitKey()
{
	KeyInit();
}
//---------------------------------------------------------------------------
EWRAM_CODE void InitSprite()
{
	SpriteInit();

	SpriteSetPalData16((u16*)&sprPal);
	SpriteSetData ((u16*)&sprTiles, SPR_IMG_BYTE);
}
//---------------------------------------------------------------------------
EWRAM_CODE void InitFont()
{
	Mode3SetFont((u8*)&shnm6x12aBitmap, SHNM_6X12A_IMG_CX, SHNM_6X12A_FONT_CX, SHNM_6X12A_FONT_CY,
	             (u16*)&shnm_fnt_txt, SHNM_FNT_FONT_CNT);
}
//---------------------------------------------------------------------------
EWRAM_CODE void InitIRQ()
{
	REG_INTERUPT = (u32)IRQUserHandler;
	REG_IE       = IRQ_BIT_TIMER0;

	REG_TM0D     = 65536 - 2621;			// (((16*1024*1024) / 64) * 10) / 1000
	REG_TM0CNT   = TM_ENABLE | TM_FREQ_PER_64 | TM_USEIRQ;

	REG_IME      = IRQ_MASTER_ON;
}
//---------------------------------------------------------------------------
EWRAM_CODE void DrawEditScreen()
{
	DrawTitle();
	CursorDraw();
	CursorDrawPointNum();

	CaslDrawLineAll();
	CaslDrawLineNum();
}
//---------------------------------------------------------------------------
EWRAM_CODE void DrawTitle()
{
	Mode3DrawFontBackGround(0, 0, (u8*)" CASL2 / COMET2 Simulator", COLOR_BLACK, COLOR_WHITE);
}
